//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Lime
#property  indicator_color2  Red
#property  indicator_color3  Gray
#property  indicator_width1  2
#property  indicator_level1  0
#property  indicator_levelcolor  Yellow
//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
//---- indicator buffers

extern bool   showArrows_set1 = true;
extern string arrowsIdentifier_set1      = "MACD Trad4 arrows";
extern color  arrowsSColor_set1         = Magenta;
extern color  arrowsBColor_set1         = Aqua;
extern int  arrowsize_set1         = 1;
//sound must be in this folder: directory\OANDA - MetaTrader\sounds
extern bool   SoundON     = false;
extern string   sound_buy = "buy.wav";
extern string   sound_sell = "sell.wav";
extern bool   Alert_MsgBoxON     = false;
extern bool EmailON=false;

extern bool   showArrows_set2 = true;
extern string arrowsIdentifier_set2      = "MACD Trad4 crossed level arrows";
extern color  arrowsSColor_set2         = Red;
extern color  arrowsBColor_set2         = Green;
extern int  arrowsize_set2         = 1;
//sound must be in this folder: directory\OANDA - MetaTrader\sounds
extern bool   SoundON2     = false;
extern string   sound_buy2 = "buy.wav";
extern string   sound_sell2 = "sell.wav";
extern bool   Alert_MsgBoxON2     = false;
extern bool   EmailON2     = false;

int flagval1 = 0;
int flagval2 = 0;

int flagval12 = 0;
int flagval22 = 0;

double     MacdBuffer[];
double     SignalBuffer[];
double     HistoBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
   SetIndexBuffer(2,HistoBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")    !! :)");
   SetIndexLabel(0,"MACD YO");
   SetIndexLabel(1,"Signal YO");
   SetIndexLabel(2,"H I S T O :):)");
//---- initialization done
   return(0);
  }
  
int deinit() {
   deleteArrows();
   return (0);
}

//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      MacdBuffer[i]=(iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i));
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_EMA,i);
//---- histogram line counted in the 3-nd buffer
   for(i=0; i<limit; i++)
      HistoBuffer[i]=(MacdBuffer[i]+SignalBuffer[i]);
//---- done
 
   
   static datetime previousTime; 
   previousTime   = Time[0];
   for(int shift=limit; shift >=0 ; shift--){   
      if (flagval1==0){         
         if ((MacdBuffer[shift]>=SignalBuffer[shift+1] && MacdBuffer[shift+1]<SignalBuffer[shift+1])){ 
            if (showArrows_set1){
               deleteArrow(Time[shift], arrowsIdentifier_set1);                       
               drawArrow(shift,arrowsBColor_set1,241,False,arrowsIdentifier_set1,arrowsize_set1);           
            }  
            if (SoundON && Time[shift]==previousTime) PlaySound(sound_buy);
            if (EmailON  && Time[shift]==previousTime) SendMail("MACD Trad4 UP! Period: "+Period(), " Symbol: " + Symbol() + " Price: "+ Close[shift]);     
            if (Alert_MsgBoxON  && Time[shift]==previousTime) Alert("MACD Trad4 UP! Period: "+Period(), " Symbol: " + Symbol() + " Price: "+ Close[shift]);            
            flagval1=1;
            flagval2=0;
         }
      } 
      
      if (flagval2==0){
         if ((MacdBuffer[shift]<=SignalBuffer[shift] && MacdBuffer[shift+1]>SignalBuffer[shift+1])){ 
         if (showArrows_set1){
               deleteArrow(Time[shift], arrowsIdentifier_set1);                       
               drawArrow(shift,arrowsSColor_set1,242,true,arrowsIdentifier_set1,arrowsize_set1);          
            }  
            if (SoundON && Time[shift]==previousTime) PlaySound(sound_sell);
            if (EmailON  && Time[shift]==previousTime) SendMail("MACD Trad4 DOWN! Period: "+Period(), " Symbol: " + Symbol() + " Price: "+ Close[shift]);     
            if (Alert_MsgBoxON  && Time[shift]==previousTime) Alert("MACD Trad4 DOWN! Period: "+Period(), " Symbol: " + Symbol() + " Price: "+ Close[shift]);     
            flagval2=1;
            flagval1=0;
         }
      } 
        
   }
   
   
   for(shift=limit; shift >=0 ; shift--){   
      if (flagval12==0){         
         if ((MacdBuffer[shift]>=indicator_level1)){ 
            if (showArrows_set2){
               deleteArrow(Time[shift], arrowsIdentifier_set2);                       
               drawArrow(shift,arrowsBColor_set2,6,False,arrowsIdentifier_set2,arrowsize_set2);           
            }  
            if (SoundON && Time[shift]==previousTime) PlaySound(sound_buy);
            if (EmailON  && Time[shift]==previousTime) SendMail("MACD Trad4 crossed level UP! Period: "+Period(), " Symbol: " + Symbol() + " Price: "+ Close[shift]);     
            if (Alert_MsgBoxON  && Time[shift]==previousTime) Alert("MACD Trad4 crossed level UP! Period: "+Period(), " Symbol: " + Symbol() + " Price: "+ Close[shift]);            
            flagval12=1;
            flagval22=0;
         }
      } 
      
      if (flagval22==0){
         if ((MacdBuffer[shift]<indicator_level1)){ 
         if (showArrows_set2){
               deleteArrow(Time[shift], arrowsIdentifier_set2);                       
               drawArrow(shift,arrowsSColor_set2,6,true,arrowsIdentifier_set2,arrowsize_set2);          
            }  
            if (SoundON && Time[shift]==previousTime) PlaySound(sound_sell);
            if (EmailON  && Time[shift]==previousTime) SendMail("MACD Trad4 crossed level DOWN! Period: "+Period(), " Symbol: " + Symbol() + " Price: "+ Close[shift]);     
            if (Alert_MsgBoxON  && Time[shift]==previousTime) Alert("MACD Trad4 crossed level DOWN! Period: "+Period(), " Symbol: " + Symbol() + " Price: "+ Close[shift]);     
            flagval22=1;
            flagval12=0;
         }
      } 
        
   }
   
     return(0);
  }
//+------------------------------------------------------------------+

void drawArrow(int i,color theColor,int theCode,bool up, string arrowsIdentifier, int arrowsize)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap;
   
   if (arrowsize < 3)   gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   else gap  = 8.0*iATR(NULL,0,20,i)/4.0;   
     
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,arrowsize);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

void deleteArrows()
{
   string lookFor       = arrowsIdentifier_set1+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }  
}
void deleteArrow(datetime time, string arrowsIdentifier)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}